LeetCode 864 - Shortest Path to Get All Keys


https://leetcode.com/problems/shortest-path-to-get-all-keys/
We are given a 2-dimensional grid"." is an empty cell, "#" is a wall, "@" is the starting point, ("a""b", ...) are keys, and ("A""B", ...) are locks.
We start at the starting point, and one move consists of walking one space in one of the 4 cardinal directions.  We cannot walk outside the grid, or walk into a wall.  If we walk over a key, we pick it up.  We can't walk over a lock unless we have the corresponding key.
For some 1 <= K <= 6, there is exactly one lowercase and one uppercase letter of the first K letters of the English alphabet in the grid.  This means that there is exactly one key for each lock, and one lock for each key; and also that the letters used to represent the keys and locks were chosen in the same order as the English alphabet.
Return the lowest number of moves to acquire all keys.  If it's impossible, return -1.

Example 1:
Input: ["@.a.#","###.#","b.A.B"]
Output: 8
Example 2:
Input: ["@..aA","..B#.","....b"]
Output: 6
迷宫遍历 + 最少步数 = BFS
注意 状态的表示即可,这里我使用了三维数组表示状态(x坐标,y坐标,身上携带的钥匙串)
内存开销是 地图大小*钥匙串 = 31 * 31 * (1<<6) a-f 6把钥匙
☝️一个技巧:使用 位运算 异或判断 身上钥匙串是否有对应的钥匙,比较方便
https://jxy370.com/index.php/2018/08/23/leetcode-864/
求最短路径第一反应就是应该是广度优先搜索,但是由于门的存在,首先寻找哪些药匙就是一个需要解决的问题,而且找到一个钥匙之后有时还需要重走走过的路回到门的地方,用普通的二维广度优先搜索显然是不行的。
找到的方法非常巧妙,其将各个钥匙的获得状态转换为二进制编码,则可以用一个6位的二进制数即小于128的数来表示状态,然后就可以将二维的搜索转换为三维,即找到某个钥匙后,获得钥匙状态改变,就可以在另一状态下继续遍历迷宫,可以以不同状态重走走过的路。
需要注意的点是,起点也是可以通过的。
https://leetcode.com/problems/shortest-path-to-get-all-keys/discuss/147696/Java-23ms-BFS-solution
This is a typical BFS shortest distance problem. The key point here is how to represent the status for each move. I use the current key we have and the position to represent the status. Also, to avoid unnecessary search, I use a nested array dist[key][i][j], which represents the distance from starting point to current status(key, i, j).
    class Status {
        int key, i, j;
        public Status(int key, int i, int j) {
            this.key = key;
            this.i = i;
            this.j = j;
        }
    }
    
    public int shortestPathAllKeys(String[] grid) {
        int success = 0, startI = 0, startJ = 0, rows = grid.length, cols = grid[0].length();
        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < cols; j++) {
                char c = grid[i].charAt(j);
                if (c >= 'A' && c <= 'F') {
                    success |= 1 << (c - 'A');
                }
                
                if (c == '@') {
                    startI = i;
                    startJ = j;
                }
            }
        }
        int[][][] dist = new int[1 << 6][rows][cols];
        for (int i = 0; i < dist.length; i++) {
            for (int j = 0; j < dist[0].length; j++) {
                for (int k = 0; k < dist[0][0].length; k++) {
                    dist[i][j][k] = Integer.MAX_VALUE;
                }
            }
        }
        Queue<Status> queue = new LinkedList<>();
        queue.offer(new Status(0, startI, startJ));
        dist[0][startI][startJ] = 0;
        int path = 0;
        int[][] dirs = {{-1, 0}, {0, 1}, {1, 0}, {0, -1}};
        while (!queue.isEmpty()) {
            int size = queue.size();
            while (size-- > 0) {
                Status status = queue.poll();
                int key = status.key, x = status.i, y = status.j;
                if (key == success) return path;
                for (int[] dir : dirs) {
                    int xx = x + dir[0], yy = y + dir[1];
                    if (xx >= 0 && xx < rows && yy >= 0 && yy < cols && grid[xx].charAt(yy) != '#') {
                        int nextKey = key;
                        char c = grid[xx].charAt(yy);
                        if (c >= 'a' && c <= 'f') {
                            nextKey = key | (1 << (c - 'a'));
                        }
                        
                        if (c >= 'A' && c <= 'F') {
                            if ((nextKey & (1 << (c - 'A'))) == 0) continue;
                        }
                        
                        if (path + 1 < dist[nextKey][xx][yy]) {
                            dist[nextKey][xx][yy] = path + 1;
                            queue.offer(new Status(nextKey, xx, yy));
                        }
                    }
                }
            }
            path++;
        }
        return -1;
    }
  1. Use Bit to represent the keys.
  2. Use State to represent visited states.
class Solution {
    class State {
        int keys, i, j;
        State(int keys, int i, int j) {
            this.keys = keys;
            this.i = i;
            this.j = j;
        }
    }
    public int shortestPathAllKeys(String[] grid) {
        int x = -1, y = -1, m = grid.length, n = grid[0].length(), max = -1;
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                char c = grid[i].charAt(j);
                if (c == '@') {
                    x = i;
                    y = j;
                }
                if (c >= 'a' && c <= 'f') {
                    max = Math.max(c - 'a' + 1, max);
                }
            }
        }
        State start = new State(0, x, y);
        Queue<State> q = new LinkedList<>();
        Set<String> visited = new HashSet<>();
        visited.add(0 + " " + x + " " + y);
        q.offer(start);
        int[][] dirs = new int[][]{{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
        int step = 0;
        while (!q.isEmpty()) {
            int size = q.size();
            while (size-- > 0) {
                State cur = q.poll();
                if (cur.keys == (1 << max) - 1) {
                    return step;
                }
                for (int[] dir : dirs) {
                    int i = cur.i + dir[0];
                    int j = cur.j + dir[1];
                    int keys = cur.keys;
                    if (i >= 0 && i < m && j >= 0 && j < n) {
                        char c = grid[i].charAt(j);
                        if (c == '#') {
                            continue;
                        }
                        if (c >= 'a' && c <= 'f') {
                            keys |= 1 << (c - 'a');
                        }
                        if (c >= 'A' && c <= 'F' && ((keys >> (c - 'A')) & 1) == 0) {
                            continue;
                        }
                        if (!visited.contains(keys + " " + i + " " + j)) {
                            visited.add(keys + " " + i + " " + j);
                            q.offer(new State(keys, i, j));
                        }
                    }
                }
            }
            step++;
        }
        return -1;
    }


Approach 2: Points of Interest + Dijkstra
Clearly, we only really care about walking between points of interest: the keys, locks, and starting position. We can use this insight to speed up our calculation.
Let's make this intuition more formal: any walk can be decomposed into primitive segments, where each segment (between two points of interest) is primitive if and only if it doesn't touch any other point of interest in between.
Then, we can calculate the distance (of a primitive segment) between any two points of interest, using a breadth first search.
Afterwards, we have some graph (where each node refers to at most 13 places, and at most 2^6 states of keys). We have a starting node (at '@' with no keys) and ending nodes (at anywhere with all keys.) We also know all the costs to go from one node to another - each node has outdegree at most 13. This shortest path problem is now ideal for using Dijkstra's algorithm.
Dijkstra's algorithm uses a priority queue to continually searches the path with the lowest cost to destination, so that when we reach the target, we know it must have been through the lowest cost path. Refer to this link for more detail.
Again, each part of the algorithm is relatively straightforward (for those familiar with BFS and Dijkstra's algorithm), but the implementation in total can be quite challenging.
  • Time Complexity: O(RC(2\mathcal{A} + 1) + \mathcal{E} \log \mathcal{N}), where R, C are the dimensions of the grid, and \mathcal{A} is the maximum number of keys, \mathcal{N} = (2\mathcal{A} + 1) * 2^\mathcal{A} is the number of nodes when we perform Dijkstra's, and \mathcal{E} = \mathcal{N} * (2 \mathcal{A} + 1) is the maximum number of edges.
  • Space Complexity: O(\mathcal{N})
    int INF = Integer.MAX_VALUE;
    String[] grid;
    int R, C;
    Map<Character, Point> location;
    int[] dr = new int[]{-1, 0, 1, 0};
    int[] dc = new int[]{0, -1, 0, 1};

    public int shortestPathAllKeys(String[] grid) {
        this.grid = grid;
        R = grid.length;
        C = grid[0].length();

        //location : the points of interest
        location = new HashMap();
        for (int r = 0; r < R; ++r)
            for (int c = 0; c < C; ++c) {
                char v = grid[r].charAt(c);
                if (v != '.' && v != '#')
                    location.put(v, new Point(r, c));
            }

        int targetState = (1 << (location.size() / 2)) - 1;
        Map<Character, Map<Character, Integer>> dists = new HashMap();
        for (char place: location.keySet())
            dists.put(place, bfsFrom(place));

        //Dijkstra
        PriorityQueue<ANode> pq = new PriorityQueue<ANode>((a, b) ->
                Integer.compare(a.dist, b.dist));
        pq.offer(new ANode(new Node('@', 0), 0));
        Map<Node, Integer> finalDist = new HashMap();
        finalDist.put(new Node('@', 0), 0);

        while (!pq.isEmpty()) {
            ANode anode = pq.poll();
            Node node = anode.node;
            int d = anode.dist;
            if (finalDist.getOrDefault(node, INF) < d) continue;
            if (node.state == targetState) return d;

            for (char destination: dists.get(node.place).keySet()) {
                int d2 = dists.get(node.place).get(destination);
                int state2 = node.state;
                if (Character.isLowerCase(destination)) //key
                    state2 |= (1 << (destination - 'a'));
                if (Character.isUpperCase(destination)) //lock
                    if ((node.state & (1 << (destination - 'A'))) == 0) // no key
                        continue;

                if (d + d2 < finalDist.getOrDefault(new Node(destination, state2), INF)) {
                    finalDist.put(new Node(destination, state2), d + d2);
                    pq.offer(new ANode(new Node(destination, state2), d+d2));
                }
            }
        }

        return -1;
    }

    public Map<Character, Integer> bfsFrom(char source) {
        int sr = location.get(source).x;
        int sc = location.get(source).y;
        boolean[][] seen = new boolean[R][C];
        seen[sr][sc] = true;
        int curDepth = 0;
        Queue<Point> queue = new LinkedList();
        queue.offer(new Point(sr, sc));
        queue.offer(null);
        Map<Character, Integer> dist = new HashMap();

        while (!queue.isEmpty()) {
            Point p = queue.poll();
            if (p == null) {
                curDepth++;
                if (!queue.isEmpty())
                    queue.offer(null);
                continue;
            }

            int r = p.x, c = p.y;
            if (grid[r].charAt(c) != source && grid[r].charAt(c) != '.') {
                dist.put(grid[r].charAt(c), curDepth);
                continue; // Stop walking from here if we reach a point of interest
            }

            for (int i = 0; i < 4; ++i) {
                int cr = r + dr[i];
                int cc = c + dc[i];
                if (0 <= cr && cr < R && 0 <= cc && cc < C && !seen[cr][cc]){
                    if (grid[cr].charAt(cc) != '#') {
                        queue.offer(new Point(cr, cc));
                        seen[cr][cc] = true;
                    }
                }
            }
        }

        return dist;
    }
}

// ANode: Annotated Node
class ANode {
    Node node;
    int dist;

    ANode(Node n, int d) {
        node = n;
        dist = d;
    }
}

class Node {
    char place;
    int state;

    Node(char p, int s) {
        place = p;
        state = s;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Node)) return false;
        Node other = (Node) o;
        return (place == other.place && state == other.state);
    }

    @Override
    public int hashCode() {
        return 256 * state + place;
    }

}

X. Approach 1: Brute Force + Permutations
这是一道最短路径的问题,但是特殊的地方在于只有我们到达某一些点之后才能解锁对应的其他的点。所以普通的最短路径的算法是不行的,需要进行一定的修改。在那之前,brute force的算法是很容易想到的,因为我们的目的是取得所有的锁,锁最多也就6个,我们可以枚举所有序列的permutation。比如我们只有三把锁,我们枚举的序列为:
  • abc
  • acb
  • bac
  • bca
  • cab
  • cba
对于每一个枚举的序列,比如abc,我们依次计算a到b和b到c的最短距离,用bfs计算即可。注意每一次拿到钥匙之后要解锁对应的部分即可。假设输入的矩阵为m x n,锁的数目为k,那么permutation的数量有k!个,序列的长度为k,所以我们一共要进行k * k次bfs,每一次的时间复杂度为O(m * n),所以总的时间复杂度为O(m * n * k * k!)


We have to pick up the keys K in some order, say K_{\sigma_i}.
For each ordering, let's do a breadth first search to find the distance to the next key.
For example, if the keys are 'abcdef', then for each ordering such as 'bafedc', we will try to calculate the candidate distance from '@' -> 'b' -> 'a' -> 'f' -> 'e' -> 'd' -> 'c'.
Between each segment of our path (and corresponding breadth-first search), we should remember what keys we've picked up. Keys that are picked up become part of a mask that helps us identify what locks we are allowed to walk through during the next breadth-first search.
Each part of the algorithm is relatively straightforward, but the implementation in total can be quite challenging. See the comments for more details.
  • Time Complexity: O(R * C * \mathcal{A} * \mathcal{A}!), where R, C are the dimensions of the grid, and \mathcal{A} is the maximum number of keys (\mathcal{A} because it is the "size of the alphabet".) Each bfs is performed up to \mathcal{A} * \mathcal{A}! times.
  • Space Complexity: O(R * C + \mathcal{A}!), the space for the bfs and to store the candidate key permutations. 


  int INF = Integer.MAX_VALUE;
  String[] grid;
  int R, C;
  Map<Character, Point> location;
  int[] dr = new int[] { -1, 0, 1, 0 };
  int[] dc = new int[] { 0, -1, 0, 1 };

  public int shortestPathAllKeys(String[] grid) {
    this.grid = grid;
    R = grid.length;
    C = grid[0].length();

    // location['a'] = the coordinates of 'a' on the grid, etc.
    location = new HashMap();
    for (int r = 0; r < R; ++r)
      for (int c = 0; c < C; ++c) {
        char v = grid[r].charAt(c);
        if (v != '.' && v != '#')
          location.put(v, new Point(r, c));
      }

    int ans = INF;
    int num_keys = location.size() / 2;
    String[] alphabet = new String[num_keys];
    for (int i = 0; i < num_keys; ++i)
      alphabet[i] = Character.toString((char) ('a' + i));
    // alphabet = ["a", "b", "c"], if there were 3 keys

    search: for (String cand : permutations(alphabet, 0, num_keys)) {
      // bns : the built candidate answer, consisting of the sum
      // of distances of the segments from '@' to cand[0] to cand[1] etc.
      int bns = 0;
      for (int i = 0; i < num_keys; ++i) {
        char source = i > 0 ? cand.charAt(i - 1) : '@';
        char target = cand.charAt(i);

        // keymask : an integer with the 0-th bit set if we picked up
        // key 'a', the 1-th bit set if we picked up key 'b', etc.
        int keymask = 0;
        for (int j = 0; j < i; ++j)
          keymask |= 1 << (cand.charAt(j) - 'a');
        int d = bfs(source, target, keymask);
        if (d == INF)
          continue search;
        bns += d;
        if (bns >= ans)
          continue search;
      }
      ans = bns;
    }

    return ans < INF ? ans : -1;
  }

  public int bfs(char source, char target, int keymask) {
    int sr = location.get(source).x;
    int sc = location.get(source).y;
    int tr = location.get(target).x;
    int tc = location.get(target).y;
    boolean[][] seen = new boolean[R][C];
    seen[sr][sc] = true;
    int curDepth = 0;
    Queue<Point> queue = new LinkedList();
    queue.offer(new Point(sr, sc));
    queue.offer(null);

    while (!queue.isEmpty()) {
      Point p = queue.poll();
      if (p == null) {
        curDepth++;
        if (!queue.isEmpty())
          queue.offer(null);
        continue;
      }
      int r = p.x, c = p.y;
      if (r == tr && c == tc)
        return curDepth;
      for (int i = 0; i < 4; ++i) {
        int cr = r + dr[i];
        int cc = c + dc[i];
        if (0 <= cr && cr < R && 0 <= cc && cc < C && !seen[cr][cc]) {
          char cur = grid[cr].charAt(cc);
          if (cur != '#') {
            if (Character.isUpperCase(cur) && (((1 << (cur - 'A')) & keymask) <= 0))
              continue; // at lock and don't have key

            queue.offer(new Point(cr, cc));
            seen[cr][cc] = true;
          }
        }
      }
    }

    return INF;
  }

  public List<String> permutations(String[] alphabet, int used, int size) {
    List<String> ans = new ArrayList();
    if (size == 0) {
      ans.add(new String(""));
      return ans;
    }

    for (int b = 0; b < alphabet.length; ++b)
      if (((used >> b) & 1) == 0)
        for (String rest : permutations(alphabet, used | (1 << b), size - 1))
          ans.add(alphabet[b] + rest);
    return ans;
  }

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts